# usage:
# dd if=/dev/zero bs=$BS count=$COUNT | ruby splice_bench.rb <sleepy|fiddle>
require 'benchmark'
require 'fiddle'
require 'sleepy_penguin'
Splice = Fiddle::Function.new(Fiddle.dlopen(nil)['splice'], [
    Fiddle::TYPE_INT, # int fd_in,
    Fiddle::TYPE_VOIDP, # loff_t *off_in
    Fiddle::TYPE_INT, # int fd_out
    Fiddle::TYPE_VOIDP, # loff_t *off_out
    Fiddle::TYPE_SIZE_T, # size_t len
    Fiddle::TYPE_INT, # unsigned int flags
  ],
  Fiddle::TYPE_SSIZE_T) # ssize_t

res = case ARGV[0]
when 'fiddle'
  warn :fiddle
  Benchmark.measure {
    begin
      s = Splice.call(0, nil, 1, nil, 4096, 0)
    end while s > 0
  }
else
  warn :sleepy
  Benchmark.measure {
    begin
      s = SleepyPenguin.splice(STDIN, STDOUT, 4096, 0)
    rescue EOFError
      break
    end while s > 0
  }
end
STDERR.puts Benchmark::CAPTION
STDERR.puts res
